﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using DeckLinkAPI;
namespace DummyProj
{
    public partial class Form1 : Form, IDeckLinkVideoOutputCallback
    {
        IDeckLinkOutput deck;
        IDeckLinkMutableVideoFrame frame;
        IDeckLink d;
        public Form1()
        {
            InitializeComponent();
            IDeckLinkIterator idl = new CDeckLinkIterator();

            idl.Next(out d);
            deck = (IDeckLinkOutput)d;
            deck.SetScheduledFrameCompletionCallback(this);
            
            deck.EnableVideoOutput(_BMDDisplayMode.bmdModeHD720p5994, _BMDVideoOutputFlags.bmdVideoOutputFlagDefault);
            deck.CreateVideoFrame(1280, 720, 1280 * 4, _BMDPixelFormat.bmdFormat8BitBGRA, _BMDFrameFlags.bmdFrameFlagDefault, out frame);

            for (int I = 0; I < 60; I++)
            {
                deck.ScheduleVideoFrame(frame, I * 1001, 1001, 60000);
            }
            deck.StartScheduledPlayback(0, 60000, 1);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            deck.StartScheduledPlayback(0 * 1001, 60000, 1);
        }

        void IDeckLinkVideoOutputCallback.ScheduledFrameCompleted(IDeckLinkVideoFrame completedFrame, _BMDOutputFrameCompletionResult result)
        {
            //If Input Present, schedule frames from there. Otherwise Schedule output frames here.
            int i = 0;
            MessageBox.Show("FrameCompleted!");

        }

        void IDeckLinkVideoOutputCallback.ScheduledPlaybackHasStopped()
        {
            MessageBox.Show("PlaybackStopped!");
        }
    }
}
